#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU 4000000UL
#include <util/delay.h>

volatile uint8_t brightness_red = 250;
volatile uint8_t brightness_green = 5;
volatile uint8_t brightness_blue = 5;

volatile uint8_t sorted_brightness[3];
volatile uint8_t map_brightness[3];

volatile int8_t minutesToGo = -1;

volatile uint8_t counter = 0;

int main(void){
	int8_t brightnesschange_red = 3;
	int8_t brightnesschange_green = 5;
	int8_t brightnesschange_blue = -4;

	int8_t RestOfMinute = 120;

	int8_t minutesToGoDisplay =0;

	int8_t timecounter=0;
	int8_t buttoncounter=0;

	DDRB = (1<<PB3|1<<PB4|1<<PB5);		// Set PB3,4,5 as output
	PORTB = 0b00000000;

	//DDRD = (0<<PD3);

	TCCR0B = (1<<CS02 | 1<<CS02);			//Set Prescaler to 1024
//	TCCR1B = (1<<WGM12 | 1<<CS12 | 1<<CS10);
//	OCR1A = 3906;

	TIMSK = (1<<OCIE0A | 1<<TOIE0);// | 1<< OCIE1A);		//Enable Interrupts Compare A & Overflow

	sei();

	minutesToGoDisplay=minutesToGo;

	while(1){


	if (minutesToGo != -1) {
		RestOfMinute--;
		if (RestOfMinute == 0 && minutesToGo > 0){
			minutesToGo--;
			RestOfMinute=120;
			minutesToGoDisplay=minutesToGo;
		}
		if (minutesToGoDisplay>0){
			if (brightness_blue==255){
				brightness_blue=5;
			}else{
				brightness_blue=255;
				minutesToGoDisplay--;
			}
		}else{
			brightness_blue=5;
		}
	}



	timecounter=10;

	while (timecounter!=0){
		timecounter--;

		_delay_ms(50);

		if((PINB & 0b00000001)==1) {
			if (buttoncounter<5) buttoncounter++;
			if (buttoncounter == 2 && minutesToGo<120){
				RestOfMinute=120;
				if(minutesToGo==-1){
					minutesToGo=1;
				}else if(minutesToGo==0){
					minutesToGo=-1;
				}else{
					minutesToGo++;
				}
			}
			minutesToGoDisplay=minutesToGo;
		}else{
			buttoncounter = 0;
		}


		switch (minutesToGo){
			case -1:
				if((brightness_red + brightnesschange_red)>250 || (brightness_red + brightnesschange_red) <5 )
					brightnesschange_red = -brightnesschange_red;
				if((brightness_green + brightnesschange_green)>250 || (brightness_green + brightnesschange_green) <5 )
					brightnesschange_green = -brightnesschange_green;
				if((brightness_blue + brightnesschange_blue)>250 || (brightness_blue + brightnesschange_blue) <5 )
					brightnesschange_blue = -brightnesschange_blue;
				brightness_red += brightnesschange_red;
				brightness_green += brightnesschange_green;
				brightness_blue += brightnesschange_blue;
				break;

			case 0:
				if(brightness_red == 5) {
						brightness_red=255;
						brightness_blue=5;
					}else if (brightness_blue == 5){
						brightness_green=5;
						brightness_blue=255;
					}else
					{
						brightness_red=5;
						brightness_blue=255;
						brightness_green=255;
					}
				break;

			default:
				if(minutesToGoDisplay==0){
					brightness_red=RestOfMinute*2;
					brightness_green=255-(2*RestOfMinute);
				}
			break;			
			}
		}
	}
	
}




void sort_brightness(void)
{
	char temp;
	
	sorted_brightness[0]=map_brightness[0];
	sorted_brightness[1]=map_brightness[1];
	sorted_brightness[2]=map_brightness[2];

	for (int i=0;i<2;i++)
	{
		for (int j=0;j<2;j++)
		{
			if(sorted_brightness[j]>sorted_brightness[j+1])
			{
				temp=sorted_brightness[j];
				sorted_brightness[j] = sorted_brightness[j+1];
				sorted_brightness[j+1]=temp;
			}
		}
	}
}




ISR(TIMER0_COMPA_vect)
//ISR(SIG_OUTPUT_COMPARE0A)
{
	if (OCR0A==map_brightness[0]) PORTB |= (1<<PB3);
	if (OCR0A==map_brightness[1]) PORTB |= (1<<PB4);
	if (OCR0A==map_brightness[2]) PORTB |= (1<<PB5);
	counter++;
	if (counter==1 )
	{
		if (sorted_brightness[counter]==OCR0A) 
		{
			OCR0A=sorted_brightness[counter+1];
		}else{
			OCR0A=sorted_brightness[counter];
		}
	}else{
		OCR0A=sorted_brightness[counter];
	}
}

ISR(TIMER0_OVF_vect)
//ISR(SIG_OVERFLOW0)
{
	map_brightness[0]=brightness_red;
	map_brightness[1]=brightness_green;
	map_brightness[2]=brightness_blue;
	sort_brightness();
	if (map_brightness[0]!=0) PORTB &=~(1<<PB3);
	if (map_brightness[1]!=0) PORTB &=~(1<<PB4);
	if (map_brightness[2]!=0) PORTB &=~(1<<PB5);
	counter = 0;
	while (sorted_brightness[counter]==0 && counter < 2) counter++;
	OCR0A=sorted_brightness[counter];
}
